<template>
  <div id="app">
    <input type="file" ref="myFiles" @change="getDataFromFile" multiple>
    <select v-model="selectedCategory" @change="changeDataTo(selectedCategory)">
      <option v-for="option in columNames" v-bind:key="option">{{option}}</option>
    </select>
    <button @click="downloadObjectAsJson()">download as json</button>
    <button @click="logData()">print data</button>
    <a :href="'data:text/json,'+JSON.stringify(aData)" download="trainData.json">download</a>
    <div class="upperContainer">
        <LinearGraph ref="DataLinearGraph"></LinearGraph>
    </div>
    <div class="horizontal">
      <div class="cgContainer">
        <CircleGraph ref= "CircleGraph"></CircleGraph> 
      </div>
      
      <div class="vertical">
        <div class="lgContainer">
          <MassLinearGraph ref="MassLinearGraph"></MassLinearGraph>
        </div>
       <input type="number" v-model="step">
       <button @mousedown="calculateSpikes(step)">calculate</button>

       <input type="number" v-model="periodicity" @change="reloadCirclePeriod()">
        <button @mousedown="setStandarPeriodiciy()">STANDAR periodicity</button>
        <button @mousedown="useFourielAsData()">use fouriel as data</button>
      </div> 
    </div>
    
  </div>
</template>

<script>
// TODO encontrar el primer punto en el que la grafica se cierra en circulo
// voltear la grafica de masa 
import CircleGraph from '../components/CircleGraph.vue'
import LinearGraph from '../components/LinearGraph.vue'
import MassLinearGraph from '../components/MassLinearGraph.vue'

export default {
  name: 'App',
  components: {
    CircleGraph,
    LinearGraph,
    MassLinearGraph
  },
  data(){
    return{
      constPhi: 0.1618,
      aData:[],
      columNames:[],
      selectedCategory:'',
      cg:'',
      lg:'',
      mg:'',
      step:0.01,
      periodicity : 1
    }
  },
  methods:{
    downloadObjectAsJson:function(){
      var exportObj = this.aData;
      var exportName = "trainData";
    var dataStr = "data:text/json;charset=utf-8," + encodeURIComponent(JSON.stringify(exportObj));
    var downloadAnchorNode = document.createElement('a');
    downloadAnchorNode.setAttribute("href",     dataStr);
    downloadAnchorNode.setAttribute("download", exportName + ".json");
    document.body.appendChild(downloadAnchorNode); // required for firefox
    downloadAnchorNode.click();
    downloadAnchorNode.remove();
  },
    logData(){
          console.log(this.aData);
          
    },
    calculateSpikes(step){    
         this.mg.pathXml = this.mg.calculatePath(this.cg.calculateSpikes(Number(step)))
    },
    reloadCircleGraph:function () {
         this.cg.pathXml = this.cg.calculatePath(this.getSelectedData(),this.periodicity)
    },
    reloadCirclePeriod:function () {
         
         this.cg.pathXml = this.cg.reloadPeriod(this.periodicity)
    },
    setStandarPeriodiciy: function (){
                                            // this number is the constant Phi
      this.periodicity = this.aData.length * this.constPhi
      this.reloadCircleGraph();
    },

    getDataFromFile: function(){
         //Retrieve all the files from the intput reference
            var files = this.$refs.myFiles.files;

            if (files) {
                for (var i=0, f; f=files[i]; i++) {
                  console.log();
                  
                    var r = new FileReader();
                    r.onload = ((e) => {
                        var contents = e.target.result;
                         var rows = contents.split('\n');
                         this.columNames = rows[0].split(',');
                         var days = [];
                         for (let i = 1; i < rows.length; i++) {
                           var temp = rows[i].split(',');
                           var day = {};
                         
                          for (let j = 1; j < temp.length; j++) {
                              day[this.columNames[j]] = temp[j];
                      
                          }
                          days.push(day); 
                         }
                         this.aData.push(days);
                         
                  
                      }
                    );
                    r.readAsText(f);
                }
                console.log("Data loaded with succes!");
                
            }
            else { alert("Failed to load files");}
      },
      getSelectedData:function(){
          var ndata = [];
        for (let i = 0; i < this.aData.length; i++) {
         var val = parseFloat(this.aData[i][this.selectedCategory])
          ndata.push(isNaN(val)?0:val);
          
        }
        return ndata;
      },
      changeDataTo: function (category) {
        var ndata = this.getSelectedData();
        
        this.cg.pathXml = this.cg.calculatePath(ndata,this.periodicity)
        this.lg.pathXml = this.lg.calculatePath(ndata)
        
      },
      useFourielAsData(){
        var points = this.mg.points
        var ndata = []
        for (let i = 0; i < points.length; i++) {
          ndata.push(points[i].mass);
          
        } 
        this.cg.pathXml = this.cg.calculatePath(ndata,this.periodicity)
        this.lg.pathXml = this.lg.calculatePath(ndata)
      }
      
      
      

  },
  mounted(){
    this.cg = this.$refs.CircleGraph
    this.lg = this.$refs.DataLinearGraph
    this.mg = this.$refs.MassLinearGraph
  
  
    
    
  }
}
</script>

<style>
body {
    display: block;
    margin: 0px;
}
#app {
  font-family: 'Avenir', Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
}
.upperContainer{
height: 33vh;
width: 100vw;
background-color: #5fa880
}
.horizontal{
  display: flex;
  height: 67vh;
width: 100vw;

background-color: #915fa8
}
.vertical{
  display: block;
  width: -webkit-fill-available;
}
.cgContainer{
   position: relative;
    height: 67vh;
    padding-left: 67vh;
    background-color: #a85f5f

}
.lgContainer{
  height: 33vh;
      width: -webkit-fill-available;
  background-color: #a8825f
}
</style>
